; code to flash LED on GP2 (pin 5)

	list      p=12f629            ; list directive to define processor
	#include <p12f629.inc>        ; processor specific variable definitions

	errorlevel  -302              ; suppress message 302 from list file

	__CONFIG   _CP_OFF & _CPD_OFF & _BODEN_OFF & _MCLRE_OFF & _WDT_OFF & _PWRTE_ON & _INTRC_OSC_NOCLKOUT  

; '__CONFIG' directive is used to embed configuration word within .asm file.
; The lables following the directive are located in the respective .inc file.
; See data sheet for additional information on configuration word settings.

;***** VARIABLE DEFINITIONS

lp3			EQU		0x20
lp2			EQU		0x21
lp1			EQU		0x22
led			EQU		0x30

;***** CONSTANTS

slp3		EQU		15				; get ~0.5s interval
slp2		EQU		131
slp1		EQU		0xFF



;***** PROGRAM CODE

		ORG     0x000				; processor reset vector

		goto    Main				; go to beginning of program


		ORG     0x004				; interrupt vector location

		retfie						; return from interrupt

Main

		bsf     STATUS,RP0			; set file register bank to 1 
		
; use internal pull-ups, except GP2

		movlw	b'110011'
		movwf	WPU					; set internal pull flags
		bcf		OPTION_REG, 7		; enable internal global pullups

; set TRISIO, all input except GP2
		
		movlw	b'111011'
		movwf	TRISIO

		bcf     STATUS,RP0			; set file register bank to 0

; main loop

Loop:   movlw	slp1 
        movwf   lp1 

Loop1:  movlw	slp2 
        movwf   lp2 

Loop2:  movlw	slp3 
        movwf   lp3 

Loop3:  decfsz  lp3 
        goto    Loop3 
        decfsz  lp2 
        goto    Loop2 
        decfsz  lp1 
        goto    Loop1 

; this assumes GP2 can not be 'read' as it is an output
; toggle output

        movlw   b'100'
        xorwf   led, F 

		movf	led, W
		movwf	GPIO
		
        goto    Loop 


		END                       ; directive 'end of program'

